
from datetime import datetime
from decimal import Decimal

class AiResult:
    """Interface of the application data type AiResult. 
       Generated by: EASy-Producer."""
 
    
    def getOneWindowConfidence(self) -> float:
        """Returns the value of {@code oneWindowConfidence}.
        
           Returns:
             - the value of oneWindowConfidence"""
        raise NotImplementedError
    
    def getTwoWindowsConfidence(self) -> float:
        """Returns the value of {@code twoWindowsConfidence}.
        
           Returns:
             - the value of twoWindowsConfidence"""
        raise NotImplementedError
    
    def getThreeWindowsConfidence(self) -> float:
        """Returns the value of {@code threeWindowsConfidence}.
        
           Returns:
             - the value of threeWindowsConfidence"""
        raise NotImplementedError
    
    def getProductId(self) -> str:
        """Returns the value of {@code productId}.
        
           Returns:
             - the value of productId"""
        raise NotImplementedError
    
    def getWheelColour(self) -> str:
        """Returns the value of {@code wheelColour}.
        
           Returns:
             - the value of wheelColour"""
        raise NotImplementedError
    
    def getEngraving(self) -> bool:
        """Returns the value of {@code engraving}.
        
           Returns:
             - the value of engraving"""
        raise NotImplementedError
    
    def getEngravingConfidence(self) -> float:
        """Returns the value of {@code engravingConfidence}.
        
           Returns:
             - the value of engravingConfidence"""
        raise NotImplementedError
    
    def getScratch(self) -> bool:
        """Returns the value of {@code scratch}.
        
           Returns:
             - the value of scratch"""
        raise NotImplementedError
    
    def getScratchConfidence(self) -> float:
        """Returns the value of {@code scratchConfidence}.
        
           Returns:
             - the value of scratchConfidence"""
        raise NotImplementedError
    
    def getImage(self) -> str:
        """Returns the value of {@code image}.
        
           Returns:
             - the value of image"""
        raise NotImplementedError
    
    
    def setOneWindowConfidence(self, v):
        """Changes the value of {@code oneWindowConfidence}.
        
           Parameters:
             - v -- the new value of oneWindowConfidence, may be of type float or the corresponding numpy type"""
        raise NotImplementedError
    
    def setTwoWindowsConfidence(self, v):
        """Changes the value of {@code twoWindowsConfidence}.
        
           Parameters:
             - v -- the new value of twoWindowsConfidence, may be of type float or the corresponding numpy type"""
        raise NotImplementedError
    
    def setThreeWindowsConfidence(self, v):
        """Changes the value of {@code threeWindowsConfidence}.
        
           Parameters:
             - v -- the new value of threeWindowsConfidence, may be of type float or the corresponding numpy type"""
        raise NotImplementedError
    
    def setProductId(self, v: str):
        """Changes the value of {@code productId}.
        
           Parameters:
             - v -- the new value of productId"""
        raise NotImplementedError
    
    def setWheelColour(self, v: str):
        """Changes the value of {@code wheelColour}.
        
           Parameters:
             - v -- the new value of wheelColour"""
        raise NotImplementedError
    
    def setEngraving(self, v: bool):
        """Changes the value of {@code engraving}.
        
           Parameters:
             - v -- the new value of engraving"""
        raise NotImplementedError
    
    def setEngravingConfidence(self, v):
        """Changes the value of {@code engravingConfidence}.
        
           Parameters:
             - v -- the new value of engravingConfidence, may be of type float or the corresponding numpy type"""
        raise NotImplementedError
    
    def setScratch(self, v: bool):
        """Changes the value of {@code scratch}.
        
           Parameters:
             - v -- the new value of scratch"""
        raise NotImplementedError
    
    def setScratchConfidence(self, v):
        """Changes the value of {@code scratchConfidence}.
        
           Parameters:
             - v -- the new value of scratchConfidence, may be of type float or the corresponding numpy type"""
        raise NotImplementedError
    
    def setImage(self, v: str):
        """Changes the value of {@code image}.
        
           Parameters:
             - v -- the new value of image"""
        raise NotImplementedError
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    oneWindowConfidence = property(getOneWindowConfidence, setOneWindowConfidence)
    twoWindowsConfidence = property(getTwoWindowsConfidence, setTwoWindowsConfidence)
    threeWindowsConfidence = property(getThreeWindowsConfidence, setThreeWindowsConfidence)
    productId = property(getProductId, setProductId)
    wheelColour = property(getWheelColour, setWheelColour)
    engraving = property(getEngraving, setEngraving)
    engravingConfidence = property(getEngravingConfidence, setEngravingConfidence)
    scratch = property(getScratch, setScratch)
    scratchConfidence = property(getScratchConfidence, setScratchConfidence)
    image = property(getImage, setImage)
    
