from datatypes.AiResult import AiResult
from datetime import datetime
from decimal import Decimal

class AiResultImpl(AiResult):
    """Implementation of the application data type AiResult. 
       Generated by: EASy-Producer."""
 
    #Mapped into properties without leading _ below resembling getter/setter
    
    _oneWindowConfidence: float = 0.0
    _twoWindowsConfidence: float = 0.0
    _threeWindowsConfidence: float = 0.0
    _productId: str = ""
    _wheelColour: str = ""
    _engraving: bool = None
    _engravingConfidence: float = 0.0
    _scratch: bool = None
    _scratchConfidence: float = 0.0
    _image: str = ""
    
    def getOneWindowConfidence(self) -> float:
        """Returns the value of {@code oneWindowConfidence}.
        
           Returns:
             - the value of oneWindowConfidence"""
        return self._oneWindowConfidence
    
    def getTwoWindowsConfidence(self) -> float:
        """Returns the value of {@code twoWindowsConfidence}.
        
           Returns:
             - the value of twoWindowsConfidence"""
        return self._twoWindowsConfidence
    
    def getThreeWindowsConfidence(self) -> float:
        """Returns the value of {@code threeWindowsConfidence}.
        
           Returns:
             - the value of threeWindowsConfidence"""
        return self._threeWindowsConfidence
    
    def getProductId(self) -> str:
        """Returns the value of {@code productId}.
        
           Returns:
             - the value of productId"""
        return self._productId
    
    def getWheelColour(self) -> str:
        """Returns the value of {@code wheelColour}.
        
           Returns:
             - the value of wheelColour"""
        return self._wheelColour
    
    def getEngraving(self) -> bool:
        """Returns the value of {@code engraving}.
        
           Returns:
             - the value of engraving"""
        return self._engraving
    
    def getEngravingConfidence(self) -> float:
        """Returns the value of {@code engravingConfidence}.
        
           Returns:
             - the value of engravingConfidence"""
        return self._engravingConfidence
    
    def getScratch(self) -> bool:
        """Returns the value of {@code scratch}.
        
           Returns:
             - the value of scratch"""
        return self._scratch
    
    def getScratchConfidence(self) -> float:
        """Returns the value of {@code scratchConfidence}.
        
           Returns:
             - the value of scratchConfidence"""
        return self._scratchConfidence
    
    def getImage(self) -> str:
        """Returns the value of {@code image}.
        
           Returns:
             - the value of image"""
        return self._image
    
    
    def setOneWindowConfidence(self, v):
        """Changes the value of {@code oneWindowConfidence}.
        
           Parameters:
             - v -- the new value of oneWindowConfidence, may be of type float or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._oneWindowConfidence = v.item()
        else:
            self._oneWindowConfidence = v
    
    def setTwoWindowsConfidence(self, v):
        """Changes the value of {@code twoWindowsConfidence}.
        
           Parameters:
             - v -- the new value of twoWindowsConfidence, may be of type float or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._twoWindowsConfidence = v.item()
        else:
            self._twoWindowsConfidence = v
    
    def setThreeWindowsConfidence(self, v):
        """Changes the value of {@code threeWindowsConfidence}.
        
           Parameters:
             - v -- the new value of threeWindowsConfidence, may be of type float or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._threeWindowsConfidence = v.item()
        else:
            self._threeWindowsConfidence = v
    
    def setProductId(self, v: str):
        """Changes the value of {@code productId}.
        
           Parameters:
             - v -- the new value of productId"""
        self._productId = v
    
    def setWheelColour(self, v: str):
        """Changes the value of {@code wheelColour}.
        
           Parameters:
             - v -- the new value of wheelColour"""
        self._wheelColour = v
    
    def setEngraving(self, v: bool):
        """Changes the value of {@code engraving}.
        
           Parameters:
             - v -- the new value of engraving"""
        if ("numpy" in str(type(v))):
            self._engraving = v.item()
        else:
            self._engraving = v
    
    def setEngravingConfidence(self, v):
        """Changes the value of {@code engravingConfidence}.
        
           Parameters:
             - v -- the new value of engravingConfidence, may be of type float or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._engravingConfidence = v.item()
        else:
            self._engravingConfidence = v
    
    def setScratch(self, v: bool):
        """Changes the value of {@code scratch}.
        
           Parameters:
             - v -- the new value of scratch"""
        if ("numpy" in str(type(v))):
            self._scratch = v.item()
        else:
            self._scratch = v
    
    def setScratchConfidence(self, v):
        """Changes the value of {@code scratchConfidence}.
        
           Parameters:
             - v -- the new value of scratchConfidence, may be of type float or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._scratchConfidence = v.item()
        else:
            self._scratchConfidence = v
    
    def setImage(self, v: str):
        """Changes the value of {@code image}.
        
           Parameters:
             - v -- the new value of image"""
        self._image = v
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    oneWindowConfidence = property(getOneWindowConfidence, setOneWindowConfidence)
    twoWindowsConfidence = property(getTwoWindowsConfidence, setTwoWindowsConfidence)
    threeWindowsConfidence = property(getThreeWindowsConfidence, setThreeWindowsConfidence)
    productId = property(getProductId, setProductId)
    wheelColour = property(getWheelColour, setWheelColour)
    engraving = property(getEngraving, setEngraving)
    engravingConfidence = property(getEngravingConfidence, setEngravingConfidence)
    scratch = property(getScratch, setScratch)
    scratchConfidence = property(getScratchConfidence, setScratchConfidence)
    image = property(getImage, setImage)
    
