
from datetime import datetime
from decimal import Decimal

class DecisionResult:
    """Interface of the application data type DecisionResult. 
       Generated by: EASy-Producer."""
 
    
    def getIo(self) -> bool:
        """Returns the value of {@code io}.
        
           Returns:
             - the value of io"""
        raise NotImplementedError
    
    def getIoReason(self) -> int:
        """Returns the value of {@code ioReason}.
        
           Returns:
             - the value of ioReason"""
        raise NotImplementedError
    
    def getNumWindows(self) -> int:
        """Returns the value of {@code numWindows}.
        
           Returns:
             - the value of numWindows"""
        raise NotImplementedError
    
    def getNumWindowsConfidence(self) -> float:
        """Returns the value of {@code numWindowsConfidence}.
        
           Returns:
             - the value of numWindowsConfidence"""
        raise NotImplementedError
    
    def getScratch(self) -> bool:
        """Returns the value of {@code scratch}.
        
           Returns:
             - the value of scratch"""
        raise NotImplementedError
    
    def getScratchConfidence(self) -> float:
        """Returns the value of {@code scratchConfidence}.
        
           Returns:
             - the value of scratchConfidence"""
        raise NotImplementedError
    
    def getWheelColour(self) -> str:
        """Returns the value of {@code wheelColour}.
        
           Returns:
             - the value of wheelColour"""
        raise NotImplementedError
    
    def getEngraving(self) -> bool:
        """Returns the value of {@code engraving}.
        
           Returns:
             - the value of engraving"""
        raise NotImplementedError
    
    def getEngravingConfidence(self) -> float:
        """Returns the value of {@code engravingConfidence}.
        
           Returns:
             - the value of engravingConfidence"""
        raise NotImplementedError
    
    def getProductId(self) -> str:
        """Returns the value of {@code productId}.
        
           Returns:
             - the value of productId"""
        raise NotImplementedError
    
    def getImage(self) -> str:
        """Returns the value of {@code image}.
        
           Returns:
             - the value of image"""
        raise NotImplementedError
    
    
    def setIo(self, v: bool):
        """Changes the value of {@code io}.
        
           Parameters:
             - v -- the new value of io"""
        raise NotImplementedError
    
    def setIoReason(self, v):
        """Changes the value of {@code ioReason}.
        
           Parameters:
             - v -- the new value of ioReason, may be of type int or the corresponding numpy type"""
        raise NotImplementedError
    
    def setNumWindows(self, v):
        """Changes the value of {@code numWindows}.
        
           Parameters:
             - v -- the new value of numWindows, may be of type int or the corresponding numpy type"""
        raise NotImplementedError
    
    def setNumWindowsConfidence(self, v):
        """Changes the value of {@code numWindowsConfidence}.
        
           Parameters:
             - v -- the new value of numWindowsConfidence, may be of type float or the corresponding numpy type"""
        raise NotImplementedError
    
    def setScratch(self, v: bool):
        """Changes the value of {@code scratch}.
        
           Parameters:
             - v -- the new value of scratch"""
        raise NotImplementedError
    
    def setScratchConfidence(self, v):
        """Changes the value of {@code scratchConfidence}.
        
           Parameters:
             - v -- the new value of scratchConfidence, may be of type float or the corresponding numpy type"""
        raise NotImplementedError
    
    def setWheelColour(self, v: str):
        """Changes the value of {@code wheelColour}.
        
           Parameters:
             - v -- the new value of wheelColour"""
        raise NotImplementedError
    
    def setEngraving(self, v: bool):
        """Changes the value of {@code engraving}.
        
           Parameters:
             - v -- the new value of engraving"""
        raise NotImplementedError
    
    def setEngravingConfidence(self, v):
        """Changes the value of {@code engravingConfidence}.
        
           Parameters:
             - v -- the new value of engravingConfidence, may be of type float or the corresponding numpy type"""
        raise NotImplementedError
    
    def setProductId(self, v: str):
        """Changes the value of {@code productId}.
        
           Parameters:
             - v -- the new value of productId"""
        raise NotImplementedError
    
    def setImage(self, v: str):
        """Changes the value of {@code image}.
        
           Parameters:
             - v -- the new value of image"""
        raise NotImplementedError
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    io = property(getIo, setIo)
    ioReason = property(getIoReason, setIoReason)
    numWindows = property(getNumWindows, setNumWindows)
    numWindowsConfidence = property(getNumWindowsConfidence, setNumWindowsConfidence)
    scratch = property(getScratch, setScratch)
    scratchConfidence = property(getScratchConfidence, setScratchConfidence)
    wheelColour = property(getWheelColour, setWheelColour)
    engraving = property(getEngraving, setEngraving)
    engravingConfidence = property(getEngravingConfidence, setEngravingConfidence)
    productId = property(getProductId, setProductId)
    image = property(getImage, setImage)
    
