from datatypes.DecisionResult import DecisionResult
from datetime import datetime
from decimal import Decimal

class DecisionResultImpl(DecisionResult):
    """Implementation of the application data type DecisionResult. 
       Generated by: EASy-Producer."""
 
    #Mapped into properties without leading _ below resembling getter/setter
    
    _io: bool = None
    _ioReason: int = 0
    _numWindows: int = 0
    _numWindowsConfidence: float = 0.0
    _scratch: bool = None
    _scratchConfidence: float = 0.0
    _wheelColour: str = ""
    _engraving: bool = None
    _engravingConfidence: float = 0.0
    _productId: str = ""
    _image: str = ""
    
    def getIo(self) -> bool:
        """Returns the value of {@code io}.
        
           Returns:
             - the value of io"""
        return self._io
    
    def getIoReason(self) -> int:
        """Returns the value of {@code ioReason}.
        
           Returns:
             - the value of ioReason"""
        return self._ioReason
    
    def getNumWindows(self) -> int:
        """Returns the value of {@code numWindows}.
        
           Returns:
             - the value of numWindows"""
        return self._numWindows
    
    def getNumWindowsConfidence(self) -> float:
        """Returns the value of {@code numWindowsConfidence}.
        
           Returns:
             - the value of numWindowsConfidence"""
        return self._numWindowsConfidence
    
    def getScratch(self) -> bool:
        """Returns the value of {@code scratch}.
        
           Returns:
             - the value of scratch"""
        return self._scratch
    
    def getScratchConfidence(self) -> float:
        """Returns the value of {@code scratchConfidence}.
        
           Returns:
             - the value of scratchConfidence"""
        return self._scratchConfidence
    
    def getWheelColour(self) -> str:
        """Returns the value of {@code wheelColour}.
        
           Returns:
             - the value of wheelColour"""
        return self._wheelColour
    
    def getEngraving(self) -> bool:
        """Returns the value of {@code engraving}.
        
           Returns:
             - the value of engraving"""
        return self._engraving
    
    def getEngravingConfidence(self) -> float:
        """Returns the value of {@code engravingConfidence}.
        
           Returns:
             - the value of engravingConfidence"""
        return self._engravingConfidence
    
    def getProductId(self) -> str:
        """Returns the value of {@code productId}.
        
           Returns:
             - the value of productId"""
        return self._productId
    
    def getImage(self) -> str:
        """Returns the value of {@code image}.
        
           Returns:
             - the value of image"""
        return self._image
    
    
    def setIo(self, v: bool):
        """Changes the value of {@code io}.
        
           Parameters:
             - v -- the new value of io"""
        if ("numpy" in str(type(v))):
            self._io = v.item()
        else:
            self._io = v
    
    def setIoReason(self, v):
        """Changes the value of {@code ioReason}.
        
           Parameters:
             - v -- the new value of ioReason, may be of type int or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._ioReason = v.item()
        else:
            self._ioReason = v
    
    def setNumWindows(self, v):
        """Changes the value of {@code numWindows}.
        
           Parameters:
             - v -- the new value of numWindows, may be of type int or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._numWindows = v.item()
        else:
            self._numWindows = v
    
    def setNumWindowsConfidence(self, v):
        """Changes the value of {@code numWindowsConfidence}.
        
           Parameters:
             - v -- the new value of numWindowsConfidence, may be of type float or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._numWindowsConfidence = v.item()
        else:
            self._numWindowsConfidence = v
    
    def setScratch(self, v: bool):
        """Changes the value of {@code scratch}.
        
           Parameters:
             - v -- the new value of scratch"""
        if ("numpy" in str(type(v))):
            self._scratch = v.item()
        else:
            self._scratch = v
    
    def setScratchConfidence(self, v):
        """Changes the value of {@code scratchConfidence}.
        
           Parameters:
             - v -- the new value of scratchConfidence, may be of type float or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._scratchConfidence = v.item()
        else:
            self._scratchConfidence = v
    
    def setWheelColour(self, v: str):
        """Changes the value of {@code wheelColour}.
        
           Parameters:
             - v -- the new value of wheelColour"""
        self._wheelColour = v
    
    def setEngraving(self, v: bool):
        """Changes the value of {@code engraving}.
        
           Parameters:
             - v -- the new value of engraving"""
        if ("numpy" in str(type(v))):
            self._engraving = v.item()
        else:
            self._engraving = v
    
    def setEngravingConfidence(self, v):
        """Changes the value of {@code engravingConfidence}.
        
           Parameters:
             - v -- the new value of engravingConfidence, may be of type float or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._engravingConfidence = v.item()
        else:
            self._engravingConfidence = v
    
    def setProductId(self, v: str):
        """Changes the value of {@code productId}.
        
           Parameters:
             - v -- the new value of productId"""
        self._productId = v
    
    def setImage(self, v: str):
        """Changes the value of {@code image}.
        
           Parameters:
             - v -- the new value of image"""
        self._image = v
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    io = property(getIo, setIo)
    ioReason = property(getIoReason, setIoReason)
    numWindows = property(getNumWindows, setNumWindows)
    numWindowsConfidence = property(getNumWindowsConfidence, setNumWindowsConfidence)
    scratch = property(getScratch, setScratch)
    scratchConfidence = property(getScratchConfidence, setScratchConfidence)
    wheelColour = property(getWheelColour, setWheelColour)
    engraving = property(getEngraving, setEngraving)
    engravingConfidence = property(getEngravingConfidence, setEngravingConfidence)
    productId = property(getProductId, setProductId)
    image = property(getImage, setImage)
    
