
from datetime import datetime
from decimal import Decimal

class MdzhOutput:
    """Interface of the application data type MdzhOutput. 
       Generated by: EASy-Producer."""
 
    
    def getProductId(self) -> str:
        """Returns the value of {@code ProductId}.
        
           Returns:
             - the value of ProductId"""
        raise NotImplementedError
    
    def getHardwareRevision(self) -> str:
        """Returns the value of {@code HardwareRevision}.
        
           Returns:
             - the value of HardwareRevision"""
        raise NotImplementedError
    
    def getWindows(self) -> int:
        """Returns the value of {@code Windows}.
        
           Returns:
             - the value of Windows"""
        raise NotImplementedError
    
    def getTiresColor(self) -> str:
        """Returns the value of {@code TiresColor}.
        
           Returns:
             - the value of TiresColor"""
        raise NotImplementedError
    
    def getPattern(self) -> bool:
        """Returns the value of {@code Pattern}.
        
           Returns:
             - the value of Pattern"""
        raise NotImplementedError
    
    def getEngravingText(self) -> str:
        """Returns the value of {@code EngravingText}.
        
           Returns:
             - the value of EngravingText"""
        raise NotImplementedError
    
    def getThickness(self) -> str:
        """Returns the value of {@code Thickness}.
        
           Returns:
             - the value of Thickness"""
        raise NotImplementedError
    
    def getWeight(self) -> str:
        """Returns the value of {@code Weight}.
        
           Returns:
             - the value of Weight"""
        raise NotImplementedError
    
    def getLength(self) -> str:
        """Returns the value of {@code Length}.
        
           Returns:
             - the value of Length"""
        raise NotImplementedError
    
    
    def setProductId(self, v: str):
        """Changes the value of {@code ProductId}.
        
           Parameters:
             - v -- the new value of ProductId"""
        raise NotImplementedError
    
    def setHardwareRevision(self, v: str):
        """Changes the value of {@code HardwareRevision}.
        
           Parameters:
             - v -- the new value of HardwareRevision"""
        raise NotImplementedError
    
    def setWindows(self, v):
        """Changes the value of {@code Windows}.
        
           Parameters:
             - v -- the new value of Windows, may be of type int or the corresponding numpy type"""
        raise NotImplementedError
    
    def setTiresColor(self, v: str):
        """Changes the value of {@code TiresColor}.
        
           Parameters:
             - v -- the new value of TiresColor"""
        raise NotImplementedError
    
    def setPattern(self, v: bool):
        """Changes the value of {@code Pattern}.
        
           Parameters:
             - v -- the new value of Pattern"""
        raise NotImplementedError
    
    def setEngravingText(self, v: str):
        """Changes the value of {@code EngravingText}.
        
           Parameters:
             - v -- the new value of EngravingText"""
        raise NotImplementedError
    
    def setThickness(self, v: str):
        """Changes the value of {@code Thickness}.
        
           Parameters:
             - v -- the new value of Thickness"""
        raise NotImplementedError
    
    def setWeight(self, v: str):
        """Changes the value of {@code Weight}.
        
           Parameters:
             - v -- the new value of Weight"""
        raise NotImplementedError
    
    def setLength(self, v: str):
        """Changes the value of {@code Length}.
        
           Parameters:
             - v -- the new value of Length"""
        raise NotImplementedError
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    ProductId = property(getProductId, setProductId)
    HardwareRevision = property(getHardwareRevision, setHardwareRevision)
    Windows = property(getWindows, setWindows)
    TiresColor = property(getTiresColor, setTiresColor)
    Pattern = property(getPattern, setPattern)
    EngravingText = property(getEngravingText, setEngravingText)
    Thickness = property(getThickness, setThickness)
    Weight = property(getWeight, setWeight)
    Length = property(getLength, setLength)
    
