
from datetime import datetime
from decimal import Decimal

class PlcOutput:
    """Interface of the application data type PlcOutput. 
       Generated by: EASy-Producer."""
 
    
    def getHW_StartProcess(self) -> bool:
        """Returns the value of {@code HW_StartProcess}.
        
           Returns:
             - the value of HW_StartProcess"""
        raise NotImplementedError
    
    def getHW_SwitchAi(self) -> bool:
        """Returns the value of {@code HW_SwitchAi}.
        
           Returns:
             - the value of HW_SwitchAi"""
        raise NotImplementedError
    
    def getPC_ReadyForRequest(self) -> bool:
        """Returns the value of {@code PC_ReadyForRequest}.
        
           Returns:
             - the value of PC_ReadyForRequest"""
        raise NotImplementedError
    
    def getPC_RobotBusyOperating(self) -> bool:
        """Returns the value of {@code PC_RobotBusyOperating}.
        
           Returns:
             - the value of PC_RobotBusyOperating"""
        raise NotImplementedError
    
    def getPC_RobotBusyOperatingAddInfo(self) -> int:
        """Returns the value of {@code PC_RobotBusyOperatingAddInfo}.
        
           Returns:
             - the value of PC_RobotBusyOperatingAddInfo"""
        raise NotImplementedError
    
    
    def setHW_StartProcess(self, v: bool):
        """Changes the value of {@code HW_StartProcess}.
        
           Parameters:
             - v -- the new value of HW_StartProcess"""
        raise NotImplementedError
    
    def setHW_SwitchAi(self, v: bool):
        """Changes the value of {@code HW_SwitchAi}.
        
           Parameters:
             - v -- the new value of HW_SwitchAi"""
        raise NotImplementedError
    
    def setPC_ReadyForRequest(self, v: bool):
        """Changes the value of {@code PC_ReadyForRequest}.
        
           Parameters:
             - v -- the new value of PC_ReadyForRequest"""
        raise NotImplementedError
    
    def setPC_RobotBusyOperating(self, v: bool):
        """Changes the value of {@code PC_RobotBusyOperating}.
        
           Parameters:
             - v -- the new value of PC_RobotBusyOperating"""
        raise NotImplementedError
    
    def setPC_RobotBusyOperatingAddInfo(self, v):
        """Changes the value of {@code PC_RobotBusyOperatingAddInfo}.
        
           Parameters:
             - v -- the new value of PC_RobotBusyOperatingAddInfo, may be of type int or the corresponding numpy type"""
        raise NotImplementedError
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    HW_StartProcess = property(getHW_StartProcess, setHW_StartProcess)
    HW_SwitchAi = property(getHW_SwitchAi, setHW_SwitchAi)
    PC_ReadyForRequest = property(getPC_ReadyForRequest, setPC_ReadyForRequest)
    PC_RobotBusyOperating = property(getPC_RobotBusyOperating, setPC_RobotBusyOperating)
    PC_RobotBusyOperatingAddInfo = property(getPC_RobotBusyOperatingAddInfo, setPC_RobotBusyOperatingAddInfo)
    
